# $Revision: 1.46 $, $Date: 2007/01/10 21:34:29 $
# TODO
# - secure webpages and dirs (separate htdocs and includes)
#
# Conditional build:
%bcond_with	apidocs	# with apidocs. not finished
#
Summary:	MediaWiki - the collaborative editing software that runs Wikipedia
Summary(pl):	MediaWiki - oprogramowanie do wsplnej edycji, na ktrym dziaa Wikipedia
Name:		mediawiki
Version:	1.8.3
Release:	1
License:	GPL
Group:		Applications/WWW
Source0:	http://dl.sourceforge.net/wikipedia/%{name}-%{version}.tar.gz
# Source0-md5:	9ef825abfcf0888b22571bbb097480f0
Source1:	%{name}.conf
Patch0:		%{name}-mysqlroot.patch
Patch1:		%{name}-confdir2.patch
URL:		http://wikipedia.sourceforge.net/
BuildRequires:	sed >= 4.0
%if %{with apidocs}
BuildRequires:	php-cli
BuildRequires:	php-pear-PhpDocumentor
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	php(mysql)
Requires:	php(pcre)
Requires:	php(xml)
Requires:	php-common >= 4:5.0
# includes/UserMailer.php:
#Requires:	php-pear-Mail
# Optional
#Suggests:	ImageMagick or php-gd for thumbnails
#Suggests:	php-zlib
#Suggests:	php-mmcache || php4-mmcache
Requires:	webapps
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_appdir		%{_datadir}/%{name}
%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}

%description
MediaWiki is the collaborative editing software that runs Wikipedia,
for a list of features please consult:
<http://meta.wikimedia.org/wiki/MediaWiki_feature_list>.

%description -l pl
MediaWiki to oprogramowanie do wsplnej edycji, na ktrym dziaa
Wikipedia. List moliwoci mona znale pod adresem:
<http://meta.wikimedia.org/wiki/MediaWiki_feature_list>.

%package setup
Summary:	MediaWiki setup package
Summary(pl):	Pakiet do wstpnej konfiguracji MediaWiki
Group:		Applications/WWW
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	php(posix)

%description setup
Install this package to configure initial MediaWiki installation. You
should uninstall this package when you're done, as it considered
insecure to keep the setup files in place.

%description setup -l pl
Ten pakiet naley zainstalowa w celu wstpnej konfiguracji MediaWiki
po pierwszej instalacji. Potem naley go odinstalowa, jako e
pozostawienie plikw instalacyjnych mogoby by niebezpieczne.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

find '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_appdir}}

cp -a config extensions images includes languages maintenance math skins $RPM_BUILD_ROOT%{_appdir}
cp -a AdminSettings.sample $RPM_BUILD_ROOT%{_sysconfdir}/AdminSettings.php

cp *.php install-utils.inc $RPM_BUILD_ROOT%{_appdir}

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post setup
chmod 770 %{_sysconfdir}

%postun setup
if [ "$1" = "0" ]; then
	chmod 750 %{_sysconfdir}
	if [ -f %{_sysconfdir}/LocalSettings.php ]; then
		chown root:http %{_sysconfdir}/LocalSettings.php
		chmod 640 %{_sysconfdir}/LocalSettings.php
	fi
fi

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerpostun -- %{name} < 1.5.3-0.2
# nuke very-old config location (this mostly for Ra)
if [ -f /etc/httpd/httpd.conf ]; then
	sed -i -e "/^Include.*%{name}.conf/d" /etc/httpd/httpd.conf
	/usr/sbin/webapp register httpd %{_webapp}
	httpd_reload=1
fi

# migrate from httpd (apache2) config dir
if [ -f /etc/httpd/%{name}.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
	mv -f /etc/httpd/%{name}.conf.rpmsave %{_sysconfdir}/httpd.conf
	/usr/sbin/webapp register httpd %{_webapp}
	httpd_reload=1
fi

# migrate from apache-config macros
if [ -f /etc/%{name}/apache.conf.rpmsave ]; then
	if [ -d /etc/apache/webapps.d ]; then
		cp -f %{_sysconfdir}/apache.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/apache.conf
	fi

	if [ -d /etc/httpd/webapps.d ]; then
		cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/httpd.conf
	fi
	rm -f /etc/%{name}/apache.conf.rpmsave
fi

# migrating from earlier apache-config?
if [ -L /etc/apache/conf.d/99_%{name}.conf ] || [ -L /etc/httpd/httpd.conf/99_%{name}.conf ]; then
	if [ -L /etc/apache/conf.d/99_%{name}.conf ]; then
		rm -f /etc/apache/conf.d/99_%{name}.conf
		/usr/sbin/webapp register apache %{_webapp}
		apache_reload=1
	fi
	if [ -L /etc/httpd/httpd.conf/99_%{name}.conf ]; then
		rm -f /etc/httpd/httpd.conf/99_%{name}.conf
		/usr/sbin/webapp register httpd %{_webapp}
		httpd_reload=1
	fi
else
	# no earlier registration. assume migration from Ra
	if [ -d /etc/apache/webapps.d ]; then
		/usr/sbin/webapp register apache %{_webapp}
		apache_reload=1
	fi
	if [ -d /etc/httpd/webapps.d ]; then
		/usr/sbin/webapp register httpd %{_webapp}
		httpd_reload=1
	fi
fi

if [ "$httpd_reload" ]; then
	%service httpd reload
fi
if [ "$apache_reload" ]; then
	%service apache reload
fi

%triggerpostun -- %{name} < 1.6.0
%banner -e %{name}-1.6 <<EOF
You may use command line upgrade script maintenance/update.php to
upgrade from previous version.
EOF

%files
%defattr(644,root,root,755)
%doc docs FAQ HISTORY INSTALL README RELEASE-NOTES UPGRADE *.sample tests
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/AdminSettings.php

%dir %{_appdir}
%{_appdir}/*.php
%{_appdir}/languages
%{_appdir}/math
%{_appdir}/images
%{_appdir}/extensions
%{_appdir}/skins
%{_appdir}/includes
%{_appdir}/maintenance

%files setup
%defattr(644,root,root,755)
%dir %attr(775,root,http) %{_appdir}/config
%{_appdir}/install-utils.inc
%{_appdir}/config/index.php

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mediawiki.spec,v $
Revision 1.46  2007/01/10 21:34:29  glen
- 1.8.3, XSS injection vulnerability was located in the AJAX support module

Revision 1.45  2006/11/21 19:56:55  glen
- rel 3: use php(extension) virtuals

Revision 1.44  2006/10/15 23:00:05  glen
- rel 2

Revision 1.43  2006/10/15 22:52:19  glen
- updated to 1.8.2

Revision 1.42  2006/10/01 17:46:40  glen
- rel 2

Revision 1.41  2006/09/29 21:25:58  glen
- update webapp triggers due apache1 package split

Revision 1.40  2006/07/10 08:49:51  glen
- 1.7.1, security and bugfix release

Revision 1.39  2006/07/08 11:26:39  glen
- 1.7.0, php < 5.0 and mysql < 4.0 no longer supported

Revision 1.38  2006/06/06 11:23:28  glen
- 1.6.7 security and bugfix maintenance release

Revision 1.37  2006/05/23 12:02:02  glen
- 1.6.6 security and bugfix maintenance release

Revision 1.36  2006/05/02 22:11:30  glen
- 1.6.4

Revision 1.35  2006/04/27 21:23:14  glen
- 1.6.3, NFY

Revision 1.34  2006/04/27 17:37:40  glen
- 1.5.8

Revision 1.33  2006/02/03 17:59:15  glen
- up to 1.5.6:
  2006-01-19: fix infinite loop bug in malformed edit comments
  2006-01-05: Protection against Windows WMF vulnerability
   Please upgrade if you have uploads enabled to avoid being a vector for unpatched clients.
  2005-12-21: Fix for remote code execution bug in 1.5 branch
- STBR

Revision 1.32  2006/02/03 16:49:02  baggins
- release 4

Revision 1.31  2006/02/02 15:14:49  glen
- update apache2 trigger to match apache-base in case somebody decides not to
  use apache2.2 virtual pkg (freedom of choice one of the pld mottos)

Revision 1.30  2006/01/04 14:06:59  glen
- use %service in trigger to respect skip auto restarts of services
- formatting
- rel 3

Revision 1.29  2005/12/11 15:58:37  glen
- rel 2

Revision 1.28  2005/12/10 23:15:13  glen
- revoke write permission from LocalSettings when uninstalling setup package

Revision 1.27  2005/12/10 23:12:00  glen
- rel 1

Revision 1.26  2005/12/10 23:09:27  glen
- updated to 1.5.3
- use webapps framework
- store LocalSettings.php in webapps dir

Revision 1.25  2005/12/10 19:46:30  glen
- 1.4.12 (security updates)

Revision 1.24  2005/11/20 22:49:03  glen
- use virtual webserver provide

Revision 1.23  2005/07/20 18:51:33  glen
- 1.4.7; another security update

Revision 1.22  2005/07/10 13:21:54  glen
- use more common %{_appdir} macro

Revision 1.21  2005/07/10 13:19:55  glen
- use apache config triggers
- 1.4.6 (security and bugfix release)

Revision 1.20  2005/06/15 12:07:50  glen
- rel 1. STBR (better this than vulnerable 1.3.9)

Revision 1.19  2005/06/14 09:55:24  glen
- 1.4.5 (security update)

Revision 1.18  2005/05/06 21:55:27  glen
- no url for dropin

Revision 1.17  2005/05/06 21:54:06  glen
- dropin source (this is my md5 and it worked. dunno what df gets)

Revision 1.16  2005/05/06 21:42:52  glen
- mysql-root patch updated

Revision 1.15  2005/05/06 21:37:26  glen
- version 1.4.4

Revision 1.14.2.1  2005/05/06 20:11:54  glen
- save work. there are other versions out...

Revision 1.14  2005/05/05 20:39:46  glen
- apache1/2 support with trigger

Revision 1.13  2005/02/28 21:42:54  qboosh
- unified

Revision 1.12  2004/12/20 14:02:40  adamg
- updated to 1.3.9 (fixes input validation vulnerability)
- belongs to Applications/WWW group
- droped Source0-size
- do not use pearprov/pearreq scripts

Revision 1.11  2004/11/03 22:22:15  ankry
- spaces -> tabs, other cosmetics

Revision 1.10  2004/11/03 22:03:18  speedo
- moved data files to _datadir
- moved config file to _sysconfdir

Revision 1.9  2004/10/28 07:34:26  snurf
- added missing br

Revision 1.8  2004/10/26 19:30:51  darekr
- fixed commitlog again, wr

Revision 1.7  2004/10/26 19:25:50  darekr
- security updated to 1.3.7
- fixed Source0
- missing file

Revision 1.6  2004/10/16 00:46:24  paladine
- updated to 1.3.6

Revision 1.5  2004/10/11 21:27:23  ankry
- typo, fix by Robert Kurowski

Revision 1.4  2004/10/01 08:42:33  paladine
- updated to 1.3.4

Revision 1.3  2004/09/08 18:35:25  qboosh
- pl
- http group for config dir should be enough

Revision 1.2  2004/09/07 16:23:28  adamg
- nah... or maybe we should remove that webbased config generator?

Revision 1.1  2004/09/06 22:10:42  djurban
- initial mediawiki, someone with expierience with packaging php
  engines please check, this is my first spec in this group
